# Formality

[![npm version](https://img.shields.io/npm/v/re-formality.svg?style=flat-square)](https://www.npmjs.com/package/re-formality)
[![build status](https://github.com/MinimaHQ/re-formality/workflows/re-formality%20pipeline/badge.svg)](https://github.com/MinimaHQ/re-formality/actions)
[![license](https://img.shields.io/npm/l/re-formality.svg?style=flat-square)](https://www.npmjs.com/package/re-formality)

Form validation tool for [`reason-react`](https://reasonml.github.io/reason-react/).

## Features
* Validation strategies
* Async validations
* Collections
* Dependent fields
* I18n compatible

## Documentation
- [Installation](./docs/01-Installation.md)
- [Validation Strategies](./docs/02-ValidationStrategies.md)
- [IO](./docs/03-IO.md)
- [Basic Usage](./docs/04-BasicUsage.md)
- [Async Validation](./docs/05-AsyncValidation.md)
- [Collections](./docs/06-Collections.md)
- [Dependent Fields](./docs/07-DependentFields.md)
- [Form Submission](./docs/08-FormSubmission.md)
- [I18n](./docs/09-I18n.md)
- [Caveats](./docs/10-Caveats.md)
- [API](./docs/11-API.md)

## Examples
* [Live demo](https://re-formality.now.sh)
* [Live @ minima.app](https://minima.app)
* [Sources](./examples)

## Contributing
See [CONTRIBUTING](./CONTRIBUTING.md).

## Alternatives
- [ReForm](https://github.com/Astrocoders/reform)<br>
  Alternative form state management solution for ReasonReact apps.

## License
See [LICENSE](./LICENSE).
